// GetIPDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GetIP.h"
#include "GetIPDlg.h"
#include "LoginInfoDlg.h"
#include "ContextHelpDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define KEY "%z]_"


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// Registry value class initializers
/*
CRegInt::CRegInt()
{
	Key = "";
	Value = NULL;
	Default = 0;
}

CRegString::CRegString()
{
	Key = "";
	Value = NULL;
	Default = "";
}
*/
/////////////////////////////////////////////////////////////////////////////
// CGetIPDlg dialog

CGetIPDlg::CGetIPDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetIPDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGetIPDlg)
	m_Destination = _T("");
	m_FormatTemplate = _T("");
	m_Frequency = _T("");
	m_IgnoreMasks = _T("");
	m_HideOnStartup = FALSE;
	m_Mask10 = FALSE;
	m_Mask172 = FALSE;
	m_Mask192 = FALSE;
	m_MaxMsg = _T("");
	m_SendOnStartup = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGetIPDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGetIPDlg)
	DDX_Control(pDX, IDC_MAXMSG, m_MaxMsgCtrl);
	DDX_Control(pDX, IDC_MESSAGES, m_MessagesCtrl);
	DDX_Control(pDX, IDC_TIMEUNITS, m_TimeUnitsCtrl);
	DDX_Control(pDX, IDC_PROTOCOL, m_ProtocolCtrl);
	DDX_Control(pDX, IDC_IGNOREMASKS, m_IgnoreMasksCtrl);
	DDX_Control(pDX, IDC_FREQUENCY, m_FrequencyCtrl);
	DDX_Control(pDX, IDC_FORMATTEMPLATE, m_FormatTemplateCtrl);
	DDX_Control(pDX, IDC_DESTINATION, m_DestinationCtrl);
	DDX_Text(pDX, IDC_DESTINATION, m_Destination);
	DDX_Text(pDX, IDC_FORMATTEMPLATE, m_FormatTemplate);
	DDX_Text(pDX, IDC_FREQUENCY, m_Frequency);
	DDX_Text(pDX, IDC_IGNOREMASKS, m_IgnoreMasks);
	DDX_Check(pDX, IDC_HIDEONSTARTUP, m_HideOnStartup);
	DDX_Check(pDX, IDC_10_x_x_x, m_Mask10);
	DDX_Check(pDX, IDC_172_16_x_x, m_Mask172);
	DDX_Check(pDX, IDC_192_168_x_x, m_Mask192);
	DDX_Text(pDX, IDC_MAXMSG, m_MaxMsg);
	DDX_Check(pDX, IDC_SENDONSTARTUP, m_SendOnStartup);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGetIPDlg, CDialog)
	//{{AFX_MSG_MAP(CGetIPDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_HIDENOW, OnHideNow)
	ON_BN_CLICKED(IDC_CONFIGURELOGIN, OnConfigureLogin)
	ON_BN_CLICKED(IDC_MYHELP, OnMyHelp)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_WM_CHAR()
	ON_WM_KEYDOWN()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDOK, OnExit)
	ON_BN_CLICKED(IDC_SAVEALL, OnSaveAll)
	ON_EN_CHANGE(IDC_FREQUENCY, OnChangeFrequency)
	ON_CBN_SELCHANGE(IDC_TIMEUNITS, OnSelchangeTimeunits)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SENDNOW, OnSendNow)
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_LBN_DBLCLK(IDC_MESSAGES, OnDblclkMessages)
	ON_BN_CLICKED(IDC_SAVELOG, OnSaveLog)
	ON_EN_CHANGE(IDC_MAXMSG, OnChangeMaxmsg)
    ON_MESSAGE( WM_TRAYNOTIFY, OnTrayNotify )
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetIPDlg message handlers

BOOL CGetIPDlg::OnInitDialog()
{
	// Dialog member variables

	RegArrayInit();
	LoadRegistry();

	CDialog::OnInitDialog();

	m_ProtocolCtrl.SetCurSel(m_Protocol);
	m_TimeUnitsCtrl.SetCurSel(m_TimeUnits);

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_Posting = 0;
	ResetTimer();  // Initialize the timed posting

	if (m_HideOnStartup)
	{
		m_HideOnce = TRUE;
		SetTimer(2,10,NULL);
	} else
		m_HideOnce = FALSE;

	if (m_SendOnStartup)
	{
		OnSendNow();
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGetIPDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGetIPDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGetIPDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGetIPDlg::OnBrowse() 
{
	MyUpdateData(TRUE);  // Don't lose what we've got already
	CFileDialog StdFileDialog(TRUE,NULL,NULL);
	StdFileDialog.DoModal();
	m_FormatTemplate = StdFileDialog.GetPathName();
	MyUpdateData(FALSE);
}

void CGetIPDlg::OnHideNow() 
{
	NOTIFYICONDATA nid;
	HICON TrayIcon;

	TrayIcon = AfxGetApp()->LoadIcon(IDI_TRAYICON);

	nid.hWnd = GetSafeHwnd();
	nid.uID = IDI_TRAYICON;
	nid.cbSize = sizeof(nid);
	nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	nid.uCallbackMessage = WM_COMMAND; //WM_TRAYNOTIFY;
	nid.hIcon = TrayIcon;
	strcpy(nid.szTip,"IP Address Poster");

	Shell_NotifyIcon(NIM_ADD,&nid);
	ShowWindow(SW_HIDE);
}

void CGetIPDlg::OnConfigureLogin() 
{
	CLoginInfoDlg LoginDlg;
	int nResponse;

	LoginDlg.m_UserID = m_Login_UserID;
	LoginDlg.m_Password = m_Login_Password;
	LoginDlg.m_LoginScript = m_Login_LoginScript;

	MyUpdateData(TRUE);  // update current variables

	nResponse = LoginDlg.DoModal();
	if (nResponse == IDOK)
	{
		m_Login_UserID = LoginDlg.m_UserID;
		m_Login_Password = LoginDlg.m_Password;
		m_Login_LoginScript = LoginDlg.m_LoginScript;
		MyUpdateData(FALSE);
	}
}

void CGetIPDlg::OnMyHelp() 
{
	OnHelp();
}

// This is really a function that is called when ESCAPE is pressed
// because IDC_SAVE ended up being 2 - same as IDCANCEL
// and I'm too lazy to fix it
void CGetIPDlg::OnSave() 
{
	OnClose();
}

void CGetIPDlg::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CDialog::OnChar(nChar, nRepCnt, nFlags);
}

void CGetIPDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}

BOOL CGetIPDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if (wParam == IDI_TRAYICON /* && lParam == 0x201 */ )
	{
		OnTrayNotify(GetSafeHwnd(), lParam, wParam);
		return FALSE;
	}
	else
		return CDialog::OnCommand(wParam, lParam);
}

void CGetIPDlg::OnCancel()
{
}

void CGetIPDlg::OnClose() 
{
	OnSaveAll();
	int i;

	// Destroy the CString objects
	for (i = 0; i < STRINGMEMBERS; i++)
	{
		regStr[i].Value->~CString();
		regStr[i].Value = NULL;
	}

	m_AddressString.~CString();
	m_FormatFilePath.~CString();

	// Destroy the registry array
	regStr.RemoveAll();
	regInt.RemoveAll();

	// Destroy the IP address array
	m_addresses.RemoveAll();

	// TODO:  delete GIP*.TMP in %TEMP%

	RemoveTrayIcon();

	CDialog::OnClose();
	ExitProcess(0);
}

void CGetIPDlg::LoadRegistry()
{
	CString strSection = "Settings";
	CWinApp* pApp = AfxGetApp();

	int i;

	for (i = 0; i < STRINGMEMBERS; i++)
	{
		if (regStr[i].Key != "")
			*(regStr[i].Value) = pApp->GetProfileString(strSection, regStr[i].Key, regStr[i].Default);
	}

	for (i = 0; i < INTMEMBERS; i++)
	{
		if (regInt[i].Key != "")
			*(regInt[i].Value) = pApp->GetProfileInt(strSection, regInt[i].Key, regInt[i].Default);
	}

	DecryptPassword();
}

void CGetIPDlg::RegArrayInit()
{
	regStr.SetSize(STRINGMEMBERS);
	regStr[0].Key = "Destination";     regStr[0].Default = "foo.com/ip.txt"; regStr[0].Value = &m_Destination;
	regStr[1].Key = "FormatTemplate";  regStr[1].Default = "";    regStr[1].Value = &m_FormatTemplate;
	regStr[2].Key = "Frequency";       regStr[2].Default = "10";  regStr[2].Value = &m_Frequency;
	regStr[3].Key = "IgnoreMasks";     regStr[3].Default = "";    regStr[3].Value = &m_IgnoreMasks;
	regStr[4].Key = "UserID";          regStr[4].Default = "";    regStr[4].Value = &m_Login_UserID;
	regStr[5].Key = "Password";        regStr[5].Default = "";    regStr[5].Value = &m_Login_Password;
	regStr[6].Key = "LoginScript";     regStr[6].Default = "";    regStr[6].Value = &m_Login_LoginScript;
	regStr[7].Key = "MaxMessages";     regStr[7].Default = "500"; regStr[7].Value = &m_MaxMsg;

	regInt.SetSize(INTMEMBERS);
	regInt[0].Key = "Mask_10";         regInt[0].Default = 1;     regInt[0].Value = &m_Mask10;
	regInt[1].Key = "Mask_172";        regInt[1].Default = 1;     regInt[1].Value = &m_Mask172;
	regInt[2].Key = "Mask_192";        regInt[2].Default = 1;     regInt[2].Value = &m_Mask192;
	regInt[3].Key = "HideOnStartup";   regInt[3].Default = 0;     regInt[3].Value = &m_HideOnStartup;
	regInt[4].Key = "Protocol";        regInt[4].Default = 0;     regInt[4].Value = &m_Protocol;
	regInt[5].Key = "TimeUnits";       regInt[5].Default = 0;     regInt[5].Value = &m_TimeUnits;
	regInt[6].Key = "SendOnStartup";   regInt[6].Default = 0;     regInt[6].Value = &m_SendOnStartup;
}

void CGetIPDlg::OnExit() 
{
	OnClose();
}

// Dumb little encryption scheme
void CGetIPDlg::EncryptPassword()
{
	int i,q,len;
	CString p;
	CString newp = "";
	p = CString(KEY) + m_Login_Password;
	len = p.GetLength();
	for (i = 0; i < len; i++)
	{
		q = (unsigned char) p.GetAt(i) - len + i; // Encryption
		if (q < 128)
			newp += (char) ('a' + 2*i);
		else if (q < 255)
		{
			newp += (char) ('A' + 2*i);
			q -= 127;
		} else
		{
			newp += (char) ('n' + 2*i);
			q -= 254;
		}
		newp += (char) q;
	}
	m_Login_Password = newp;
//	AfxMessageBox(CString("Encrypted password '") + newp + "'");
}

void CGetIPDlg::DecryptPassword()
{
	int i,q,len;
	CString p;
	CString newp = "";
	p = m_Login_Password;
	if (p == "") return;
	len = p.GetLength();
	for (i = len-1; i > 0; i -= 2)
	{
		q = (unsigned char) p.GetAt(i) + (len/2) - (i/2);
		if (p.GetAt(i-1) == (char) ('n' + i+1))
			q += 254;
		if (p.GetAt(i-1) == (char) ('A' + i+1))
			q += 127;
		else if (p.GetAt(i-1) != (char) ('a' + 2*(i/2)))
		{
			ErrorLog("Warning: Corrupt password.  Please re-enter.");
			newp = "";
			m_Login_Password = "";
			break;
		}
		newp += (char) q;
	}
	if (newp.GetLength() > (int) strlen(KEY))
	{
		newp.MakeReverse();
		m_Login_Password = newp.Right(newp.GetLength() - strlen(KEY));
	}
//	AfxMessageBox(CString("Decrypted password '") + m_Login_Password + "'");
}

void CGetIPDlg::OnSaveAll() 
{
	CString strSection = "Settings";
	CWinApp* pApp = AfxGetApp();

	int i;
	MyUpdateData(TRUE);  // Get current info from dialog
	EncryptPassword();
	for (i = 0; i < STRINGMEMBERS; i++)
	{
		if (regStr[i].Key != "")
			pApp->WriteProfileString(strSection, regStr[i].Key, *(regStr[i].Value));
	}

	for (i = 0; i < INTMEMBERS; i++)
	{
		if (regInt[i].Key != "")
			pApp->WriteProfileInt(strSection, regInt[i].Key, *(regInt[i].Value));
	}

	DecryptPassword();
}

void CGetIPDlg::MyUpdateData(BOOL Init)
{
	UpdateData(Init);
	if (Init == FALSE) // Dialog box being initialized
	{
		m_ProtocolCtrl.SetCurSel(m_Protocol);
		m_TimeUnitsCtrl.SetCurSel(m_TimeUnits);
	} else // Data being retrieved
	{
		m_Protocol = m_ProtocolCtrl.GetCurSel();
		if (m_Protocol == CB_ERR)
			m_Protocol = 0;
		m_TimeUnits = m_TimeUnitsCtrl.GetCurSel();
		if (m_TimeUnits == CB_ERR)
			m_TimeUnits = 0;
	}
}

void CGetIPDlg::OnChangeFrequency() 
{
	ResetTimer();	
}

void CGetIPDlg::OnSelchangeTimeunits() 
{
	ResetTimer();	
}

void CGetIPDlg::ResetTimer()
{
	int units;
	ULONG freq;
	ULONG mstime;
	UpdateData(TRUE);  // Use current values;

	units = m_TimeUnitsCtrl.GetCurSel();
	freq = atol(m_Frequency);
	if (freq == 0)
		freq = 10;  // zero is not a good default!
	if (units == CB_ERR)
		units = 2;
	switch (units)
	{
		case 0: mstime = freq * (1000 * 60 * 60 * 24);  break;  // Days
		case 1: mstime = freq * (1000 * 60 * 60);  break;       // Hours
		case 2: mstime = freq * (1000 * 60);  break;            // Minutes
		case 3: mstime = freq * (1000);  break;                 // Seconds
		default: mstime = freq * (1000*60);       // Default to Minutes
	}
	if (mstime < 1000)
		mstime = 1000;             // Don't try to post faster than once every second
	KillTimer(1);
	SetTimer(1,mstime,NULL);
}

void CGetIPDlg::OnTimer(UINT nIDEvent) 
{
	CDialog::OnTimer(nIDEvent);

	if (m_HideOnce)
	{
		if (IsWindowVisible())
		{
			m_HideOnce = FALSE;
			OnHideNow();
			KillTimer(2);
		}
		return;
	}

	DoSend();
}

void CGetIPDlg::OnSendNow() 
{
	DoSend();
}

int CGetIPDlg::CreateIPAddressFile()
{
	char temppath[MAX_PATH];
	char tempfile[MAX_PATH];
	CStdioFile formatfile;
	CStdioFile newfile;
	CString sLine;
	CString fAddress;   // filtered IP addresses
	BOOL IsTempFormat = FALSE;

	if (m_FormatTemplate != "")
	{
		if (formatfile.Open(m_FormatTemplate,CFile::modeRead | CFile::typeText) == FALSE)
		{
			ErrorLog("Error: Unable to open format file " + m_FormatTemplate);
			return -1;
		}
	} else
	{  // Get a temporary format file for our own nefarious purposes
		IsTempFormat = TRUE;
		if (GetTempPath(MAX_PATH,temppath) == 0)
		{
			ErrorLog("Error: Unable to retrieve path to temp directory");
			return -1;
		}
		
		if (GetTempFileName(temppath,"GIP",0,tempfile) == 0)
		{
			ErrorLog("Error: Unable to create temporary file " + CString(tempfile) + " in " + temppath);
			return -1;
		}
		if (formatfile.Open(tempfile,CFile::modeWrite | CFile::typeText) == FALSE)
		{
			ErrorLog("Error: Unable to write to temporary format file " + CString(tempfile));
			return -1;
		}

		// Write basic information to an on-the-fly format file

		sLine.LoadString(IDS_DEFAULTFORMAT);
		formatfile.Write(sLine,sLine.GetLength());

		// Close and re-open the on-the-fly format file for reading.

		formatfile.Close();
		if (formatfile.Open(tempfile,CFile::modeRead | CFile::typeText) == FALSE)
		{
			ErrorLog("Error: Unable to reopen temporary format file " + CString(tempfile));
			return -1;
		}
	}

	// Get a temporary file for the post-parsing format file

	if (GetTempPath(MAX_PATH,temppath) == 0)
	{
		ErrorLog("Error: Unable to retrieve path to temp directory");
		return -1;
	}
	
	if (GetTempFileName(temppath,"GIP",0,tempfile) == 0)
	{
		ErrorLog("Error: Unable to create temporary file " + CString(tempfile) + " in " + temppath);
		return -1;
	}

	if (newfile.Open(tempfile,CFile::modeWrite | CFile::typeText) == FALSE)
	{
		ErrorLog("Error: Unable to write to temporary file " + CString(tempfile));
		return -1;
	}

	fAddress = FilterAddress();

	while (!feof(formatfile.m_pStream))
	{
		formatfile.ReadString(sLine);
		// Process the line looking for our variables (currently only %IP% is defined)
		sLine.Replace("%IP%",fAddress);
		newfile.WriteString(sLine + "\n");
	}

	sLine = formatfile.GetFilePath();

	formatfile.Close();
	m_FormatFilePath = newfile.GetFilePath();
	newfile.Close();

	if (IsTempFormat == TRUE)
		CFile::Remove(sLine);

	return 0;
}

void CGetIPDlg::ErrorLog(CString errmsg)
{
	CTime t = CTime::GetCurrentTime();
	m_MessagesCtrl.AddString(t.Format("%m/%d %H:%M:%S - ") + errmsg);
	// If user selected something, don't scroll away
	// Scroll new message into view if there is either nothing selected, or the
	// current selection is in the viewable screen .
	if ((m_MessagesCtrl.GetCurSel() == -1) ||
		(m_MessagesCtrl.GetCurSel() > m_MessagesCtrl.GetCount() - 6))
	{
		m_MessagesCtrl.SetCurSel(m_MessagesCtrl.GetCount() - 1);  // scroll the listbox
		m_MessagesCtrl.SetCurSel(-1); // unselect the item
	}
	// If there are too many messages in the log, kill the oldest messages
	while (m_MessagesCtrl.GetCount() > atol(m_MaxMsg))  // Shouldn't ever be more than once, but...
	{
		m_MessagesCtrl.DeleteString(0);
	}
}

// Transfer the file in m_FormatFileObj to the destination in m_Destination
// via the protocol index in m_ProtocolCtrl
int CGetIPDlg::SendFileViaTransport()
{
	MyUpdateData(TRUE);  // Get current protocol selection
	switch(m_Protocol)
	{
		case 0:  return SendFileViaFTP();
		case 1:  return SendFileViaHTTP();
		case 2:  return SendFileViaWindowsNetwork();
		default: ErrorLog("Error:  Undefined protocol!");
	}
	return -1;
}

int CGetIPDlg::SendFileViaFTP()
{
	// m_Destination should be in one of the following formats:
	// ftp://server/path/file   e.g.  ftp://ftp.mydomain.com/pub/ip.txt
	// server/path/file         e.g.  ftp.mydomain.com/pub/ip.txt
	// server/file              e.g.  ftp.mydomain.com/ip.txt

	// server is either a standard server.com type string or a server.com:port type string

	CInternetSession session("Get IP", 1, PRE_CONFIG_INTERNET_ACCESS);
	CFtpConnection *ftp;
	CString dest;
	CString server;
	CString path;
	CString file;
	int port = 21;
	int index;
	char buf[1024];

	dest = m_Destination;
	dest.Replace("ftp://","");

	if (dest.Find('/') == -1)
	{
		ErrorLog("Error: Destination must be of the format \"server/file\"");
		return -1;
	}
	server = dest.Left(dest.Find('/'));
	
	//Find the port number if it exists
	index = server.Find(':');
	if ((index != -1) && (index < server.GetLength() - 1))
	{
		port = atoi(server.Mid(index + 1));
		server = server.Left(index);
	}

	file = dest.Mid(dest.ReverseFind('/') + 1);
	if (dest.ReverseFind('/') == dest.Find('/'))
		path = "";
	else
		path = dest.Mid(dest.Find('/') + 1,dest.ReverseFind('/') - dest.Find('/') - 1); 

/*
	afxDump << "m_Destination = " << m_Destination << "\n";
	afxDump << "dest = " << dest << "\n";
	afxDump << "server = " << server << "\n";
	afxDump << "port = " << port << "\n";
	afxDump << "path = " << path << "\n";
	afxDump << "file = " << file << "\n";
	afxDump << "user = " << m_Login_UserID << "\n";
	afxDump << "password = " << m_Login_Password << "\n";
*/

	try
	{
		ftp = session.GetFtpConnection(server,m_Login_UserID,m_Login_Password,port,FALSE);
	}
	catch( CInternetException* e )
	{
		e->GetErrorMessage(buf,1024);
		ErrorLog("Unable to connect to FTP server:  " + CString(buf));
		e->Delete();
		return -1;
	}

	if (path != "")
	{
		if (ftp->SetCurrentDirectory(path) == 0)
			if (ftp->SetCurrentDirectory("/" + path) == 0)
				ErrorLog("Warning: Unable to set current FTP directory to " + path);
	}

	if (ftp->PutFile(m_FormatFilePath,file,FTP_TRANSFER_TYPE_ASCII) == 0)
		ErrorLog("Error: Unable to transfer IP information to file " + file +
		         ", error " + CString(ltoa(GetLastError(),buf,10)));

	ftp->Close();

	ftp->~CFtpConnection();
	delete(ftp);
	return 0;
}

int CGetIPDlg::SendFileViaHTTP()
{
	return 0;
}

int CGetIPDlg::SendFileViaWindowsNetwork()
{
	// m_Destination should be in the following formats:
	// \\server\path\file   e.g.  \\bonzo\public\ip.txt


	return 0;
}

CString CGetIPDlg::FilterAddress()
{
	int i;
	CString result = "";
	MyUpdateData(TRUE);   // Grab latest checkbox changes
	CString cMask,oneMask;
	BOOL ignore = FALSE;

	for (i = 0; i < m_addresses.GetSize(); i++)
	{
		ignore = FALSE;
		if ((m_addresses[i].Left(3) == "10.") && (m_Mask10 == TRUE))
			continue;
		if ((m_addresses[i].Left(7) == "172.16.") && (m_Mask172 == TRUE))
			continue;
		if ((m_addresses[i].Left(8) == "192.168.") && (m_Mask192 == TRUE))
			continue;
		cMask = m_IgnoreMasks;
		while (cMask != "")
		{
			if (cMask.Find(';') != -1)
				oneMask = cMask.Left(cMask.Find(';'));
			else
				oneMask = cMask;
			if ((m_addresses[i].Left(oneMask.Find('*'))) == cMask.Left(oneMask.Find('*')))
			{
				ignore = TRUE;
				break;
			}
			if (cMask.GetLength() <= oneMask.GetLength() + 1)
				break;
			cMask = cMask.Mid(oneMask.GetLength() + 1);
		}
		if (!ignore) 
		{
			if (result == "")
				result += m_addresses[i];
			else
				result += ", " + m_addresses[i];
		}
	}
	if (result == "")
		result = "(none)";
	return result;
}

BOOL CGetIPDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if (pHelpInfo->iContextType == HELPINFO_WINDOW)
	{
		switch(pHelpInfo->iCtrlId)
		{
			case IDC_PROTOCOL:       ContextHelp("Protocol Combo Box",IDS_HELP_PROTOCOL); break;
			case IDC_DESTINATION:    ContextHelp("Destination",IDS_HELP_DESTINATION); break;
			case IDC_IGNOREMASKS:    ContextHelp("Ignore Masks",IDS_HELP_IGNOREMASKS); break;
			case IDC_FREQUENCY:      ContextHelp("Sending Frequency",IDS_HELP_FREQUENCY); break;
			case IDC_TIMEUNITS:      ContextHelp("Time Units Combo Box",IDS_HELP_TIMEUNITS); break;
			case IDC_192_168_x_x:    ContextHelp("192.168.*.* Mask",IDS_HELP_MASK192); break;
			case IDC_172_16_x_x:     ContextHelp("172.16.*.* Mask",IDS_HELP_MASK172); break;
			case IDC_10_x_x_x:       ContextHelp("10.*.*.* Mask",IDS_HELP_MASK10); break;
			case IDC_FORMATTEMPLATE: ContextHelp("Format Template File",IDS_HELP_FORMATTEMPLATE); break;
			case IDC_BROWSE:         ContextHelp("Browse for Template Button",IDS_HELP_BROWSE); break;
			case IDC_MYHELP:         ContextHelp("Help Button",IDS_HELP_MYHELP); break;
			case IDC_HIDEONSTARTUP:  ContextHelp("Hide on Startup Option",IDS_HELP_HIDEONSTARTUP); break;
			case IDC_HIDENOW:        ContextHelp("Hide Now Button",IDS_HELP_HIDENOW); break;
			case IDC_CONFIGURELOGIN: ContextHelp("Configure Login Button",IDS_HELP_CONFIGURELOGIN); break;
			case IDC_SAVEALL:        ContextHelp("Save all Options Button",IDS_HELP_SAVEALL); break;
			case IDC_SENDNOW:        ContextHelp("Send IP Information Now Button",IDS_HELP_SENDNOW); break;
			case IDC_CLEAR:          ContextHelp("Clear Message Log",IDS_HELP_CLEAR); break;
			case IDC_MESSAGES:       ContextHelp("Message Log",IDS_HELP_MESSAGES); break;
			case IDOK:               ContextHelp("Exit Program",IDS_HELP_EXIT); break;
			default:                 ContextHelp("No Help Associated",IDS_HELP_NOHELP);
		}
		return FALSE;
	} else return CDialog::OnHelpInfo(pHelpInfo);
}

void CGetIPDlg::ContextHelp(CString Title, int HelpID)
{
	CContextHelpDlg helpDlg;
	CString HelpText;

	HelpText.LoadString(HelpID);
	helpDlg.HelpTitle(Title);
	helpDlg.HelpText(HelpText);
	helpDlg.DoModal();
}

void CGetIPDlg::OnClear() 
{
	m_MessagesCtrl.ResetContent();	
}

void CGetIPDlg::OnDblclkMessages() 
{
	if (m_MessagesCtrl.GetCurSel() != -1)
	{
		CString temp;
		CContextHelpDlg helpDlg;
		m_MessagesCtrl.GetText(m_MessagesCtrl.GetCurSel(),temp);
		helpDlg.HelpTitle("Message Detail");
		helpDlg.HelpText(temp);
		helpDlg.DoModal();
	}
}

void CGetIPDlg::OnTrayNotify(HWND Wind, LPARAM lParam, WPARAM wParam)
{
	if (lParam == 515) // double-click
	{
		RemoveTrayIcon();
        SendMessage(WM_SYSCOMMAND,SC_RESTORE,0);
		ShowWindow(SW_SHOW);
	}
}

void CGetIPDlg::RemoveTrayIcon()
{
	NOTIFYICONDATA nid;
	HICON TrayIcon;

	TrayIcon = AfxGetApp()->LoadIcon(IDI_TRAYICON);

	nid.hWnd = GetSafeHwnd();
	nid.uID = IDI_TRAYICON;
	nid.cbSize = sizeof(nid);
	nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	nid.uCallbackMessage = WM_COMMAND; //WM_TRAYNOTIFY;
	nid.hIcon = TrayIcon;
	strcpy(nid.szTip,"IP Address Poster");

	Shell_NotifyIcon(NIM_DELETE,&nid);

}

void CGetIPDlg::OnSaveLog() 
{
    CString sPathName;
    CFileDialog StdDialog(FALSE,".txt");
    CStdioFile outFile;
    long result, nLines, i;
    CString sText;

    result = StdDialog.DoModal();
    if (result == IDOK)
    {
        sPathName = StdDialog.GetPathName();
        if (outFile.Open(sPathName,CFile::modeCreate | CFile::modeWrite | CFile::typeText))
        {
			nLines = m_MessagesCtrl.GetCount();
			for (i = 0; i < nLines; i++)
			{
				m_MessagesCtrl.GetText(i,sText);
				sText += "\n";
	            outFile.WriteString(sText);
			}
            outFile.Close();
        } else
        {
            sText = "Unable to open file \"";
            sText += sPathName;
            sText += "\" for writing.";
            MessageBox(sText,"Error opening file",MB_ICONWARNING);
        }
    }
}

void CGetIPDlg::OnChangeMaxmsg() 
{
	UpdateData(TRUE);	
}

void CGetIPDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if (nType == SIZE_MINIMIZED)
	{
		OnHideNow();
	}
}

void CGetIPDlg::DoSend()
{
// TODO:  Add a timeout		

	if (m_Posting)
		return;
	m_Posting = 1;

//	CSocket lSocket;
	char namebuf[256];
	CString buffer;
	int i,j;
	m_addresses.RemoveAll();
	m_AddressString = "";

	if (gethostname(namebuf, 256) != 0) {
		buffer = "Host name unavailable";
	};
	HOSTENT *ph = gethostbyname(namebuf);
	if (!ph) {
		buffer = "IP address unavailable";
		return;
	};

	char digtxt[5];
	for (i = 0; ph->h_addr_list[i]; i++) {
		buffer = "";
		for (j = 0; j < ph->h_length; j++) {
			buffer += ltoa((unsigned char) (ph->h_addr_list[i][j]),digtxt,10);
			if (j != ph->h_length - 1)
			{
				buffer += ".";
			}
		}
		m_AddressString += buffer;
		m_addresses.Add(buffer);
 		if (ph->h_addr_list[i+1] != 0) m_AddressString += ", ";
	}
	
	if (CreateIPAddressFile() != 0)
	{
		ErrorLog("Error: Unable to create temporary file; aborting transfer");
		m_Posting = 0;
		return;
	}

	if (SendFileViaTransport() == -1)
	{
		ErrorLog("Error:  Unable to send file to destination " + m_Destination);
	} else
	{
		ErrorLog("Status: Successfully sent address to " + m_Destination);
	}

	// Get rid of our temporary file

	CFile::Remove(m_FormatFilePath);

	m_Posting = 0;
}
